/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifndef O2SCL_BASE_IOC_H
#define O2SCL_BASE_IOC_H
#include <string>
#include <o2scl/collection.h>
#include <o2scl/funct.h>
#include <o2scl/mm_funct.h>
#include <o2scl/multi_funct.h>
#include <o2scl/table.h>

#ifndef DOXYGENP
namespace o2scl {
#endif

  /** 
      \brief Setup I/O objects for base library classes


   */
  class base_ioc {

  public:

    base_ioc() {
      bool_io=new bool_io_type("bool");
      char_io=new char_io_type("char");
      double_io=new double_io_type("double");
      int_io=new int_io_type("int");
      long_io=new long_io_type("long");
      string_io=new string_io_type("string");
      word_io=new word_io_type("word");
      //ovector_io=new ovector_io_type("ovector");
      //omatrix_io=new omatrix_io_type("omatrix");
      //ovector_int_io=new ovector_int_io_type("ovector_int");
      //omatrix_int_io=new omatrix_int_io_type("omatrix_int");
      //ovector_cx_io=new ovector_cx_io_type("ovector_cx");
      //omatrix_cx_io=new omatrix_cx_io_type("omatrix_cx");
      table_io=new table_io_type("table");
    }

    ~base_ioc() {
      delete bool_io;
      delete char_io;
      delete double_io;
      delete int_io;
      delete long_io;
      delete string_io;
      delete word_io;
      //delete ovector_io;
      //delete omatrix_io;
      //delete ovector_int_io;
      //delete omatrix_int_io;
      //delete ovector_cx_io;
      //delete omatrix_cx_io;
      delete table_io;
    }

    bool_io_type *bool_io;
    char_io_type *char_io;
    double_io_type *double_io;
    int_io_type *int_io;
    long_io_type *long_io;
    string_io_type *string_io;
    word_io_type *word_io;
    //ovector_io_type *ovector_io;
    //omatrix_io_type *omatrix_io;
    //ovector_int_io_type *ovector_int_io;
    //omatrix_int_io_type *omatrix_int_io;
    //ovector_cx_io_type *ovector_cx_io;
    //omatrix_cx_io_type *omatrix_cx_io;
    table_io_type *table_io;
    
  protected:

#ifndef DOXYGENP

#endif
  
  };

#ifndef DOXYGENP
}
#endif

#endif
